<!DOCTYPE html>
<html lang="en" data-mode="dark">
  <head prefix="og: http://ogp.me/ns#">
    <meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<meta name="generator" content="Hugo 0.68.3">
<meta name="theme" content="Color Your World -- gitlab.com/rmaguiar/hugo-theme-color-your-world">
























<title>Read Me | QEMU QED</title>


<meta name="author" content="Ethan Gates">
<meta name="description" content="A copy of the README.md file.">


<meta name="robots" content="index follow">
<meta name="referrer" content="no-referrer-when-downgrade">




  
    <link rel="canonical" href="https://example.com/usage/readme/">
  








<meta property="og:site_name" content="QEMU QED">
<meta property="og:title" content="Read Me">
<meta property="og:description" content="A copy of the README.md file.">
  <meta property="og:url" content="https://example.com/usage/readme/">








  <meta property="og:type" content="article">
  
  

  
  
  
    <meta name="twitter:creator" content="@@the_bfool">
  
  

  <meta name="twitter:site" content="@@the_bfool">







  <meta name="twitter:dnt" content="on">












<meta name="theme-color" content="#222">

<meta name="apple-mobile-web-app-capable" content="yes">
<meta name="apple-mobile-web-app-status-bar-style" content="default">










  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    
    
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
        
      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  

    
    

    

      
      
    

  







  <script type="application/ld+json">
    {
      "@context": "https://schema.org",
      "@type": "Article",
      "mainEntityOfPage": {
        "@type": "WebSite",
        "@id": "https:\/\/example.com\/"
      },
      "headline": "Read Me",
      "description": "A copy of the README.md file.",
      
      "url": "https:\/\/example.com\/usage\/readme\/",
      "inLanguage": "en",
      "datePublished": "0001-01-01",
      
      "wordCount" : "1805",
      "publisher": {
        "@type": "Person",
        "name": "Ethan Gates"
      },
      "author": {
        "@type": "Person",
        "name": "Ethan Gates",
        "description": "User Support Lead for the EaaSI program of work",
        "sameAs": ["https://github.com/EG-tech","https://gitlab.com/EG-tech","https://twitter.com/@the_bfool"]
      }
    }
  </script>






<link rel="stylesheet" href="/css/main.min.css">



<noscript>

  
  

  

    
      <meta name="theme-color" content="#dd587c">
    

  

  <style>
  
    html {
      --accent: #dd587c;
    }
  
    .req-js {
      display: none;
    }
    
  </style>
  
</noscript>






  <link rel="preload" href="/fonts/open-sans-v17-latin-700.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-700.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-italic.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-italic.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-regular.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/open-sans-v17-latin-regular.woff2" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/oswald-v29-latin-700.woff" as="font" crossorigin="anonymous">

  <link rel="preload" href="/fonts/oswald-v29-latin-700.woff2" as="font" crossorigin="anonymous">













  <link rel="me" href="https://github.com/EG-tech"> 

  <link rel="me" href="https://gitlab.com/EG-tech"> 

  <link rel="me" href="https://twitter.com/@the_bfool"> 







  <script>
    
      'use strict';

// Get default accent colors



// Get CSS transition


// =================================================
// Mode switcher + Custom accent color
// Based on: https://gist.github.com/regpaq/04c67e8aceecbf0fd819945835412d1f
// =================================================



const ROOT = document.documentElement;

const SHEET = document.documentElement.style;
const META_THEME_COLOR = document.querySelector('meta[name=theme-color]');

// Set the dark
function setDark() {
  ROOT.dataset.mode = 'dark'
};

// Set the light
function setLight() {
  ROOT.dataset.mode = 'light'
};

// Initialization triggers light/dark mode based on prior preference, then OS setting
// And yes, I know 'true' here is a string
if(localStorage.getItem('isDark') == 'true') {
  setDark()
} else if(localStorage.getItem('isDark') == 'false') {
  setLight()

  

};




// TODO
// Maybe I should rethink this ...
function getAccent() {
  if (ROOT.dataset.mode === 'dark') {
  
    if (localStorage.getItem('darkAccent') === null) {
      
      
      
      var currentAccent = "#dd587c"
    } else {
    
      var currentAccent = localStorage.getItem('darkAccent')
      
      
      
    }
  } else if (ROOT.dataset.mode === 'light') {

    if (localStorage.getItem('lightAccent') === null) {
  
      
      

      var currentAccent = "#225670"
    } else {
      var currentAccent = localStorage.getItem('lightAccent')
      
      
      
    }
  };
  
  return currentAccent
};

var activeAccent = getAccent();

// Set the active accent color for these right after setting mode color
// Should mitigate any flickering
SHEET.setProperty('--accent', activeAccent);

// Also meta-theme cuz, why not
META_THEME_COLOR.setAttribute('content', activeAccent);


function updateAccent() {
  var activeAccent = getAccent();

  SHEET.setProperty('--accent', activeAccent);
  PALETTE.value = activeAccent;
  META_THEME_COLOR.setAttribute('content', activeAccent);
};


document.addEventListener('DOMContentLoaded', function () {

  // Update the color picker with the active accent color 
  PALETTE.value = activeAccent;

  // Smooth transition, only when changing modes (and not loading pages)
  function smoothTransition() {
    document.body.style.transition 
    = document.querySelector('header').style.transition
    = document.querySelector('footer').style.transition
    = 'background-color .3s ease, color .3s ease'
  };
  
  // Give the user a choice
  function userModeChange() {
  
    smoothTransition();

    if (ROOT.dataset.mode == 'light') {
      setDark();
      localStorage.setItem('isDark', 'true')

      
      
    } else {
      setLight();
      localStorage.setItem('isDark', 'false')
      
      
      
    };
    
    updateAccent()
  };

  
  // TEST
  // Keyboard shortcut for mode change, here for testing purposes only
  // CTRL + ALT + M
  


  
  
  // Mode change button
  document.querySelector('footer button')
    .addEventListener('click', userModeChange)
})

    
  </script>



  </head>

  <body>

    <header>
      

  <a href="/">QEMU QED</a>




  
    <nav aria-label="Main menu.">
      <ul>
        
          <li>
            <a class="btn" href="/installing/">Installing QEMU</a>
          </li>
        
          <li>
            <a class="btn" href="/usage/">Using QEMU</a>
          </li>
        
          <li>
            <a class="btn" href="/recipes/">Recipes</a>
          </li>
        
          <li>
            <a class="btn" href="/glossary/">Glossary</a>
          </li>
        
          <li>
            <a class="btn" href="/resources/">More Resources</a>
          </li>
        
          <li>
            <a class="btn" href="/contact/">Contact</a>
          </li>
        
      </ul>
    </nav>
  


    </header>

    <div class="filler">
      

  <main>
    <article>
      <header>
        
        <h1>Read Me</h1>

        
          <section class="terms">
            <ul><li><a class="btn" href="/tags/extra/">extra</a></li><li><a class="btn" href="/tags/markdown/">markdown</a></li></ul>
          </section>
        
        
        
      </header>
    
      
  <details class="toc" open>
    <summary class="outline-dashed">
      Contents
    </summary>
    
    <nav id="TableOfContents">
  <ul>
    <li><a href="#screenshots">Screenshots</a></li>
    <li><a href="#requirements">Requirements</a></li>
    <li><a href="#installation">Installation</a></li>
    <li><a href="#customization">Customization</a>
      <ul>
        <li><a href="#lightdark-mode-colors">Light/dark mode colors</a></li>
        <li><a href="#accent-color">Accent color</a></li>
        <li><a href="#syntax-highlighting">Syntax highlighting</a></li>
      </ul>
    </li>
    <li><a href="#image-processing">Image processing</a></li>
    <li><a href="#shortcodes">Shortcodes</a>
      <ul>
        <li><a href="#social">Social</a></li>
        <li><a href="#contact-form">Contact form</a></li>
      </ul>
    </li>
    <li><a href="#miscellaneous">Miscellaneous</a>
      <ul>
        <li><a href="#rich-content">Rich content</a></li>
        <li><a href="#404">404</a></li>
        <li><a href="#custom-front-matter-params">Custom front matter params</a></li>
        <li><a href="#custom-partials">Custom partials</a></li>
        <li><a href="#more-params">More params</a></li>
      </ul>
    </li>
    <li><a href="#acknowledgements">Acknowledgements</a></li>
    <li><a href="#sponsoring">Sponsoring</a></li>
  </ul>
</nav>
  </details>

      







































  




<p><a href="https://color-your-world-demo.netlify.app/">Live demo (on Netlify)</a> | <a href="https://themes.gohugo.io/theme/hugo-theme-color-your-world/">Demo (on Hugo Themes)</a></p>
<p><strong>Color Your World</strong> is a <a href="https://gohugo.io">Hugo</a> theme developed around a single experiment that led me to this:</p>
<p>










  




  
  

    <img
      
      loading="lazy"
      src="https://gitlab.com/rmaguiar/hugo-theme-color-your-world/-/raw/master/images/color-picker.png"
      alt="HTML color picker with 12 presets."
    />

  

</p>
<p>It&rsquo;s a HTML color picker. Along with some vanilla JS, it allows anyone to change what I&rsquo;ll be calling here&hellip; the <strong>accent color</strong>, a color used mostly in interactive elements.</p>
<p>I liked the result so much that I decided to use it on my main site, but I also want to share it, in case anyone wants to tinker with it.</p>
<p>It makes heavy use of <a href="https://gohugo.io/hugo-pipes">Hugo Pipes</a> and I highly recommend using <code>--minify</code> when building!</p>
<p>I&rsquo;ve been working on this theme for so long that there are features I don&rsquo;t even remember anymore&hellip; But here are <em>some</em>:</p>
<ul>
<li>Customizable light/dark mode;</li>
<li>Customizable &ldquo;accent color&rdquo; (in an user-level);</li>
<li>Keyboard-friendly;</li>
<li>Privacy-aware to an extent (no Google Analytics/Fonts, Disqus, etc);</li>
<li>Social shortcode including centralized and decentralized platforms;</li>
<li>Contact form shortcode (via <a href="https://formspree.io">Formspree</a>);</li>
<li>Open Graph, Twitter Cards and Structured Data (schema.org) meta tags;</li>
<li>Responsive images via image processing;</li>
<li>Basic search functionality via <a href="https://github.com/krisk/Fuse">Fuse.js</a>;</li>
<li>Image lazy loading;</li>
<li><strong>noscript</strong> capable to an extent (except for KaTeX and search functionality).</li>
</ul>
<h2 id="screenshots">Screenshots</h2>
<p>










  




  
  

    <img
      
      loading="lazy"
      src="https://gitlab.com/rmaguiar/hugo-theme-color-your-world/-/raw/master/images/screenshot.png"
      alt="Theme screenshot in dark mode."
    />

  

</p>
<p>










  




  
  

    <img
      
      loading="lazy"
      src="https://gitlab.com/rmaguiar/hugo-theme-color-your-world/-/raw/master/images/screenshot2.png"
      alt="Theme screenshot in light mode."
    />

  

</p>
<h2 id="requirements">Requirements</h2>
<ul>
<li>Hugo Extended</li>
<li>Minimum version: 0.73.0</li>
</ul>
<h2 id="installation">Installation</h2>
<p>If you have git installed, you can do the following at the CLI within the Hugo directory:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-bash" data-lang="bash">git clone https://gitlab.com/rmaguiar/hugo-theme-color-your-world.git themes/color-your-world
</code></pre></div><p>For more information read the <a href="https://gohugo.io/overview/installing/">Hugo official setup guide</a>.</p>
<h2 id="customization">Customization</h2>
<h3 id="lightdark-mode-colors">Light/dark mode colors</h3>
<p>Both color palettes can be found in <code>assets/scss/colors/variables.scss</code>.</p>
<h3 id="accent-color">Accent color</h3>
<p>By default, there are 2 accent colors plus 10 on the <code>exampleSite</code>, distributed into pairs.</p>
<p>You can change the default mode and accent colors in the config:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">style</span><span class="p">]</span>

  <span class="c"># Dark mode as default</span>
  <span class="c"># User preferences (site/system settings) will still have priority over it</span>
  <span class="c"># The default is false</span>
  <span class="nx">isDark</span> <span class="p">=</span> <span class="kc">true</span>

  <span class="c"># Accent colors for light and dark mode respectively</span>
  <span class="nx">lightAccent</span>  <span class="p">=</span> <span class="s2">&#34;#225670&#34;</span> <span class="c"># Default is &#34;#225670&#34;</span>
  <span class="nx">darkAccent</span>   <span class="p">=</span> <span class="s2">&#34;#dd587c&#34;</span> <span class="c"># Default is &#34;#dd587c&#34;</span>

  <span class="c"># More colors, pick as many as you want (not really sure if there&#39;s a limit)</span>
  <span class="c"># Apparently these may not show up on every modern browser (ie.: Firefox)</span>
  <span class="c"># There&#39;s no default value. Used here just as example</span>
  <span class="nx">presets</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;#1f676b&#34;</span><span class="p">,</span> <span class="s2">&#34;#f3a530&#34;</span><span class="p">,</span> <span class="s2">&#34;#902b37&#34;</span><span class="p">,</span> <span class="s2">&#34;#1dbc91&#34;</span><span class="p">,</span> <span class="s2">&#34;#754e85&#34;</span><span class="p">,</span> <span class="s2">&#34;#7fc121&#34;</span><span class="p">,</span> <span class="s2">&#34;#a8314a&#34;</span><span class="p">,</span> <span class="s2">&#34;#ff7433&#34;</span><span class="p">,</span> <span class="s2">&#34;#3e6728&#34;</span><span class="p">,</span> <span class="s2">&#34;#c063bd&#34;</span> <span class="p">]</span>
</code></pre></div><h3 id="syntax-highlighting">Syntax highlighting</h3>
<p>This theme comes with two chroma styles, meant to be used with light and dark mode respectively. These are <strong>Solarized Dark</strong> for light mode and <strong>Monokai</strong> for dark mode.</p>
<p>










  




  
  

    <img
      
      loading="lazy"
      src="https://gitlab.com/rmaguiar/hugo-theme-color-your-world/-/raw/master/images/syntax-highlight.gif"
      alt="Syntax highlighting in both dark and light modes."
    />

  

</p>
<p>It&rsquo;s worth noting that I&rsquo;m not using the original stylesheets, but modified stylesheets based on the <a href="https://github.com/mpchadwick/pygments-high-contrast-stylesheets">pygments-high-contrast-stylesheets</a> (aka &ldquo;WCAG AA passing Pygments stylesheets&rdquo;).</p>
<p>In case you want to change it, it can be found in <code>assets/scss/colors/chroma</code> as <code>light.scss</code> and <code>dark.scss</code>.</p>
<p>The lines below are <strong>required</strong> in your config file to make use of this feature:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">markup</span><span class="p">]</span>
  <span class="p">[</span><span class="nx">markup</span><span class="p">.</span><span class="nx">highlight</span><span class="p">]</span>
    <span class="nx">noClasses</span> <span class="p">=</span> <span class="kc">false</span>
</code></pre></div><p>To disable it, you can just remove the <code>noClasses = false</code> (as its default value is <code>true</code>) and add the lines below:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">]</span>
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">style</span><span class="p">]</span>
    <span class="nx">useCustomChroma</span> <span class="p">=</span> <span class="kc">false</span>
</code></pre></div><h2 id="image-processing">Image processing</h2>
<p>By default, images with width equal or greater than 1280 pixels are processed (resized) into 3 resolutions: 1280x, 960x and 640x (this one with quality at 90, as opposed to the default 75).</p>
<p>You can change this behavior via config:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">imageProc</span><span class="p">]</span>
  <span class="nx">highRes</span>   <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;1280x&#34;</span><span class="p">,</span> <span class="s2">&#34;1280w&#34;</span> <span class="p">]</span>
  <span class="nx">mediumRes</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;960x&#34;</span><span class="p">,</span> <span class="s2">&#34;960w&#34;</span> <span class="p">]</span>
  <span class="nx">lowRes</span>    <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;640x q90&#34;</span><span class="p">,</span> <span class="s2">&#34;640w&#34;</span> <span class="p">]</span>
  <span class="c"># entry = [ resize options, condition ]</span>
  
  <span class="c"># Images with width equal or greater this value</span>
  <span class="c"># will be processed into the 3 resolutions above</span>
  <span class="c"># Valid only for images rendered via markdown</span>
  <span class="c"># The default value is 1280</span>
  <span class="nx">markupAutoResizeWidth</span> <span class="p">=</span> <span class="mi">1280</span>
</code></pre></div><p>The shortcodes <code>img</code> and <code>figure</code> will <strong>always</strong> process images and cover images will <em>also</em> process resolutions for Open Graph (1200x630) and Twitter (1280x640).</p>
<h2 id="shortcodes">Shortcodes</h2>
<p>The most complex shortcodes here are the <code>social</code> and <code>contact-form</code>. They can be used to inject a list of social platform links and a contact form, respectively.</p>
<h3 id="social">Social</h3>
<p>Here I make a distinction between centralized and decentralized platforms.</p>
<p>Since decentralized platforms introduced the concept of &ldquo;instances&rdquo;. It&rsquo;s not uncommon that a single person owns multiple accounts, in multiple instances, in the same platform.</p>
<p>This distinction should make the setup easier.</p>
<p>Here&rsquo;s an example of config file:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">centralized</span><span class="p">]</span>
  <span class="nx">facebook</span>      <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;Zuckerburg&#34;</span> <span class="p">]</span>
  <span class="nx">flickr</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">github</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">gitlab</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">instagram</span>     <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">keybase</span>       <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">linkedin</span>      <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">medium</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">reddit</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">snapchat</span>      <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">soundcloud</span>    <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">stackOverflow</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">strava</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">telegram</span>      <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">twitch</span>        <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">twitter</span>       <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;@birb&#34;</span> <span class="p">]</span>
  <span class="nx">vimeo</span>         <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">whatsapp</span>      <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;number&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">xing</span>          <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;username&gt;&#34;</span> <span class="p">]</span>
  <span class="nx">youtube</span>       <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;&lt;channelid&gt;&#34;</span> <span class="p">]</span>
  <span class="c">#entry         = [ &#34;username&#34;, &#34;label (optional)&#34; ]</span>
  
  <span class="c"># The &#34;entry&#34; here IS important. It&#39;s used to load the data.</span>

<span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">]</span>

  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">element</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://app.element.io/#/user/&lt;username&gt;:matrix.org&#34;</span><span class="p">,</span> <span class="s2">&#34;matrix.org&#34;</span> <span class="p">]</span>
    <span class="c">#entry = [ &#34;full url&#34;, &#34;label (required)&#34; ]</span>
    
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">funkwhale</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://open.audio/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;open.audio&#34;</span> <span class="p">]</span>
    
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">mastodon</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://mastodon.social/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;mastodon.social&#34;</span> <span class="p">]</span>
    <span class="mi">2</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://mastodon.too/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;mastodon.too&#34;</span> <span class="p">]</span>
    <span class="mi">3</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://yet.another.one/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;yet.another.one&#34;</span> <span class="p">]</span>
    
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">matrix</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://matrix.to/#/&lt;username&gt;:matrix.org&#34;</span><span class="p">,</span> <span class="s2">&#34;matrix.org&#34;</span> <span class="p">]</span>
    <span class="mi">2</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://matrix.to/#/&lt;username&gt;:other.org&#34;</span><span class="p">,</span> <span class="s2">&#34;other.org&#34;</span> <span class="p">]</span>
    
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">peertube</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://peertube.something/accounts/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;peertube.something&#34;</span> <span class="p">]</span>
    
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">social</span><span class="p">.</span><span class="nx">decentralized</span><span class="p">.</span><span class="nx">pixelfed</span><span class="p">]</span>
    <span class="mi">1</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;https://pixelfed.social/&lt;username&gt;&#34;</span><span class="p">,</span> <span class="s2">&#34;pixelfed.social&#34;</span> <span class="p">]</span>
    
  <span class="c"># The &#34;entry&#34; here ISN&#39;T important. It&#39;s used for nothing.</span>
</code></pre></div><p>This information will also be used to generate social meta tags (ie.: rel=&quot;me&rdquo; and Schema.org).</p>
<h3 id="contact-form">Contact form</h3>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="c"># Contact form shortcode</span>
<span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">contact</span><span class="p">]</span>

  <span class="c"># formspree.io Form ID</span>
  <span class="nx">formspreeFormId</span> <span class="p">=</span> <span class="s2">&#34;example&#34;</span>
  
  <span class="c"># Autocomplete [on/off] and min character length for message</span>
  <span class="nx">autoComplete</span>      <span class="p">=</span> <span class="kc">false</span> <span class="c"># Default is false</span>
  <span class="nx">messageMinLength</span>  <span class="p">=</span> <span class="mi">140</span>   <span class="c"># Default is 140</span>
  
  <span class="c"># Subject</span>
  <span class="c"># You can set a single value below (and it will cease to be a dropdown),</span>
  <span class="c"># BUT KEEP IT AS AN ARRAY</span>
  <span class="c"># It can also be disabled entirely (and it will turn into a text field)</span>
  <span class="nx">subject</span> <span class="p">=</span> <span class="p">[</span> <span class="s1">&#39;Just saying &#34;hi&#34;&#39;</span><span class="p">,</span> <span class="s2">&#34;I know what you did last winter&#34;</span><span class="p">,</span> <span class="s2">&#34;... Is that a sloth?&#34;</span><span class="p">,</span> <span class="s2">&#34;お前はもう死んでいる。&#34;</span> <span class="p">]</span>

  <span class="c"># Text placeholders. As usual, comment the lines if you don&#39;t want use them</span>
  <span class="c"># The &#34;subject&#34; below will only be used if the &#34;subject&#34; above doesn&#39;t exist (ie.: commented/deleted)</span>
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">contact</span><span class="p">.</span><span class="nx">placeholder</span><span class="p">]</span>
    <span class="nx">name</span>    <span class="p">=</span> <span class="s2">&#34;Jane Doe&#34;</span>
    <span class="nx">email</span>   <span class="p">=</span> <span class="s2">&#34;janedoe@example.com&#34;</span>
    <span class="nx">subject</span> <span class="p">=</span> <span class="s1">&#39;Just saying &#34;hi&#34;&#39;</span>
    <span class="nx">message</span> <span class="p">=</span> <span class="s2">&#34;Aenean lacinia bibendum nulla sed consectetur. Vivamus sagittis lacus vel augue laoreet rutrum faucibus dolor auctor. Donec ullamcorper nulla non metus auctor fringilla nullam quis risus.&#34;</span>
</code></pre></div><h2 id="miscellaneous">Miscellaneous</h2>
<h3 id="rich-content">Rich content</h3>
<p>Minimal effort was put here, since I don&rsquo;t use this feature. I recommend that you create your own <code>assets/scss/rich-content.scss</code>.</p>
<h3 id="404">404</h3>
<p>A <strong>really</strong> basic 404 page can be generated via config file by using:</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">notFound</span><span class="p">]</span>
  <span class="nx">title</span>         <span class="p">=</span> <span class="s2">&#34;Page not found&#34;</span>
  <span class="nx">description</span>   <span class="p">=</span> <span class="s2">&#34;This page was not found.&#34;</span>
  <span class="nx">paragraph</span>     <span class="p">=</span> <span class="s2">&#34;Nothing to see here, buddy.&#34;</span>
</code></pre></div><h3 id="custom-front-matter-params">Custom front matter params</h3>
<ul>
<li><code>mainTitle</code> (string): Can be used to replace the <code>&lt;title&gt;</code> meta tag, if you wish it to be different from the <code>&lt;h1&gt;</code> (which will still use the <code>title</code> param);</li>
<li><code>sitemapExclude</code> (true|false): Can be used to exclude a page/section from the sitemap;</li>
<li><code>noindex</code> (true|false): Similar to the above. Can be used to exclude a page/section from being indexed (by bots or your own site). It will change the meta tag <code>robots</code> to <code>noindex</code> and the page(s) will not be added to the site&rsquo;s search index.</li>
</ul>
<h3 id="custom-partials">Custom partials</h3>
<ul>
<li>The site title can be replaced by creating a file named <code>layouts/partials/custom/site-title.html</code>;</li>
<li>Custom favicons can be used by creating a file named <code>layouts/partials/custom/head-append.html</code>;</li>
<li>Custom CSS can be imported into the main CSS file by creating a file named <code>static/css/custom.css</code> or <code>assets/scss/custom.scss</code>;</li>
<li>The <code>copyright</code> param can be replaced by creating a file named <code>layouts/partials/custom/copyright.html</code>.</li>
</ul>
<h3 id="more-params">More params</h3>
<p>More possible params for your config file (or front matter):</p>
<div class="highlight"><pre class="chroma" aria-label="Box containing code sample." tabindex=0><code class="language-toml" data-lang="toml"><span class="p">[</span><span class="nx">params</span><span class="p">]</span>
  
  <span class="c"># Site description</span>
  <span class="nx">description</span> <span class="p">=</span> <span class="s2">&#34;John Doe&#39;s personal website&#34;</span>
  
  <span class="c"># Author</span>
  <span class="nx">author</span>      <span class="p">=</span> <span class="s2">&#34;John Doe&#34;</span>
  <span class="nx">authorDesc</span>  <span class="p">=</span> <span class="s2">&#34;Some indescribable horror.&#34;</span>
  
  <span class="c"># Site cover, for Open Graph, Twitter Cards and Schema.org</span>
  <span class="c"># It will be used if the current page doesn&#39;t have an image cover</span>
  <span class="c"># File will be picked from the &#34;assets&#34; directory</span>
  <span class="c"># Comment the lines if you don&#39;t want to use it</span>
  <span class="nx">cover</span>     <span class="p">=</span> <span class="s2">&#34;img/cover.jpg&#34;</span>
  <span class="nx">coverAlt</span>  <span class="p">=</span> <span class="s2">&#34;A placeholder that doesn&#39;t deserve to be described.&#34;</span>
  
  <span class="c"># Shows a message in the footer about JavaScript being disabled</span>
  <span class="c"># The default is false</span>
  <span class="nx">hasNoscriptNotice</span> <span class="p">=</span> <span class="kc">true</span>
  
  <span class="c"># Default path for images in posts</span>
  <span class="c"># ie.: &#34;content/some-post/img&#34;</span>
  <span class="c"># Can also be set PER PAGE</span>
  <span class="c"># It can be used to reduce repetition</span>
  <span class="c"># There&#39;s no default value</span>
  <span class="nx">imgPath</span> <span class="p">=</span> <span class="s2">&#34;img&#34;</span>
  
  <span class="c"># Default classes for markup image </span>
  <span class="c"># Modifies the default behavior of images placed via markdown</span>
  <span class="c"># Can also be set PER PAGE via front matter</span>
  <span class="c"># Available classes are: border and borderless</span>
  <span class="c"># There&#39;s no default value</span>
  <span class="nx">markupImgClass</span> <span class="p">=</span> <span class="s2">&#34;borderless&#34;</span>
  
  <span class="c"># This will append a separator (of your choice) along the site title to your &lt;title&gt;</span>
  <span class="c"># ie.: | ❚ - – — • ⚫</span>
  <span class="c"># You can disabled it PER PAGE by using &#34;disableTitleSeparator&#34; at front</span>
  <span class="c"># matter or disable it entirely by commenting the line below</span>
  <span class="nx">titleSeparator</span> <span class="p">=</span> <span class="s2">&#34;|&#34;</span>
  
  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">search</span><span class="p">]</span>
  
    <span class="c"># Enable search form (at the post list)</span>
    <span class="c"># The default value is false</span>
    <span class="nx">enable</span> <span class="p">=</span> <span class="kc">true</span>
  
    <span class="c"># Limit search results</span>
    <span class="c"># The default value is 30</span>
    <span class="nx">maxResults</span> <span class="p">=</span> <span class="mi">15</span>
    
    <span class="c"># Limit seach field input and pattern matching</span>
    <span class="nx">minLength</span> <span class="p">=</span> <span class="mi">2</span>   <span class="c"># Default is 3</span>
    <span class="nx">maxLength</span> <span class="p">=</span> <span class="mi">42</span>  <span class="c"># Default is 32</span>
    
    <span class="c"># Optional placeholder for search field</span>
    <span class="nx">placeholder</span> <span class="p">=</span> <span class="s2">&#34;ie.: lorem ipsum&#34;</span>
    
    <span class="c"># Stop word filter list</span>
    <span class="c"># Can also be set PER PAGE via front matter</span>
    <span class="c"># There&#39;s no default value</span>
    <span class="nx">stopWords</span> <span class="p">=</span> <span class="p">[</span> <span class="s2">&#34;a&#34;</span><span class="p">,</span> <span class="s2">&#34;an&#34;</span><span class="p">,</span> <span class="s2">&#34;and&#34;</span><span class="p">,</span> <span class="s2">&#34;in&#34;</span><span class="p">,</span> <span class="s2">&#34;the&#34;</span><span class="p">,</span> <span class="s2">&#34;to&#34;</span><span class="p">,</span> <span class="s2">&#34;was&#34;</span><span class="p">,</span> <span class="s2">&#34;were&#34;</span><span class="p">,</span> <span class="s2">&#34;with&#34;</span> <span class="p">]</span>

  <span class="p">[</span><span class="nx">params</span><span class="p">.</span><span class="nx">style</span><span class="p">]</span>
  
    <span class="c"># Disable the use of system settings (prefers-color-scheme)</span>
    <span class="c"># Can be used as a workaround for Chrome on Linux</span>
    <span class="c"># (Issue 998903: Dark Gtk theme does not affect prefers-color-scheme media query)</span>
    <span class="c"># The default is false</span>
    <span class="nx">ignoreSystemSettings</span> <span class="p">=</span> <span class="kc">true</span>
  
    <span class="c"># Use an icon or text for footnote return links</span>
    <span class="c"># The default is false</span>
    <span class="nx">hasIconAsFootnoteReturnLink</span> <span class="p">=</span> <span class="kc">true</span>
    
    <span class="c"># For the social shortcode</span>
    <span class="c"># Use flexbox (with flex-grow) or grid (equal width)</span>
    <span class="c"># The default is false</span>
    <span class="nx">socialIsFlex</span> <span class="p">=</span> <span class="kc">true</span>
    
    <span class="c"># Keep anchor links hidden until it&#39;s focused/hovered</span>
    <span class="c"># The default is false</span>
    <span class="nx">hideAnchors</span> <span class="p">=</span> <span class="kc">true</span>

    <span class="c"># CSS animation transition when changing colors</span>
    <span class="c"># The default is &#34;.5s ease&#34;</span>
    <span class="nx">changeTransition</span> <span class="p">=</span> <span class="s2">&#34;.3s ease&#34;</span>
</code></pre></div><h2 id="acknowledgements">Acknowledgements</h2>
<ul>
<li><a href="https://fontawesome.com/">Font Awesome</a> and <a href="https://forkaweso.me/">Fork Awesome</a> for the icons;</li>
<li><a href="https://gist.github.com/nickpunt">@nickpunt</a> and <a href="https://gist.github.com/regpaq">@regpaq</a> for the <a href="https://gist.github.com/regpaq/04c67e8aceecbf0fd819945835412d1f">dark/light mode switcher</a> idea;</li>
<li>Glenn McComb and <a href="https://glennmccomb.com/articles/how-to-build-custom-hugo-pagination/">his article</a> about custom pagination with Hugo;</li>
<li>JeffProd and <a href="https://en.jeffprod.com/blog/2018/build-your-own-Hugo-website-search-engine/">his article</a> about building a custom search engine for Hugo;</li>
<li>Many people <a href="https://gist.github.com/eddiewebb/735feb48f50f0ddd65ae5606a1cb41ae">on this forked gist</a> for their takes on Fuse.js + Hugo;</li>
<li>Philip Walton and <a href="https://philipwalton.github.io/solved-by-flexbox/demos/sticky-footer/">his sticky footer solution</a> with Flexbox;</li>
<li><a href="https://github.com/krisk/Fuse">Fuse.js</a>;</li>
<li><a href="https://katex.org/">KaTeX</a>;</li>
<li>Hugo and <a href="https://discourse.gohugo.io/">its community</a>.</li>
</ul>
<h2 id="sponsoring">Sponsoring</h2>
<p>If this repo was useful or helpful to you in any way, please consider buying me a coffee:</p>
<p><a href="https://www.buymeacoffee.com/rmaguiar" target="_blank" rel="noopener noreferrer"><img src="https://cdn.buymeacoffee.com/buttons/lato-orange.png" alt="Buy Me A Coffee" style="height: 51px !important;width: 217px !important;"></a></p>



    </article>
  </main>


    </div>
    
    <footer>
      

  
    <p>Copyright © EaaSI <a href="https://gitlab.com/eaasi/qemu-qed">GitLab</a> Contributers;
Site built using <a href="https://gohugo.io/">Hugo</a> and the <a href="https://gitlab.com/rmaguiar/hugo-theme-color-your-world">Color Your World</a> theme by Raphael Aguiar</p>
  













<section class="req-js">
  <button class="outline-dashed" title="Change to light/dark mode."><svg xmlns="http://www.w3.org/2000/svg" aria-hidden="true"><use xlink:href="#adjust"/></svg></button><input class="outline-dashed" type="color" list="presets" value="#dd587c" title="Change accent color." aria-label="Change accent color."><datalist id="presets"><option value="#225670"><option value="#dd587c"><option value="#1f676b"><option value="#f3a530"><option value="#902b37"><option value="#1dbc91"><option value="#754e85"><option value="#7fc121"><option value="#a8314a"><option value="#ff7433"><option value="#3e6728"><option value="#c063bd"></datalist>
</section>



  <noscript>
    <p class="noscript">Unable to execute JavaScript. Some features were disabled.</p>
  </noscript>



    </footer>
    
    <svg xmlns="http://www.w3.org/2000/svg" width="0" height="0" aria-hidden="true">
      <symbol viewBox="0 0 512 512" id="adjust">
        <path d="M8 256c0 136.966 111.033 248 248 248s248-111.034 248-248S392.966 8 256 8 8 119.033 8 256zm248 184V72c101.705 0 184 82.311 184 184 0 101.705-82.311 184-184 184z"/>
      </symbol>
      
      
      
      
  
<symbol viewBox="0 0 448 512" id="hashtag">
  <path d="M440.667 182.109l7.143-40c1.313-7.355-4.342-14.109-11.813-14.109h-74.81l14.623-81.891C377.123 38.754 371.468 32 363.997 32h-40.632a12 12 0 0 0-11.813 9.891L296.175 128H197.54l14.623-81.891C213.477 38.754 207.822 32 200.35 32h-40.632a12 12 0 0 0-11.813 9.891L132.528 128H53.432a12 12 0 0 0-11.813 9.891l-7.143 40C33.163 185.246 38.818 192 46.289 192h74.81L98.242 320H19.146a12 12 0 0 0-11.813 9.891l-7.143 40C-1.123 377.246 4.532 384 12.003 384h74.81L72.19 465.891C70.877 473.246 76.532 480 84.003 480h40.632a12 12 0 0 0 11.813-9.891L151.826 384h98.634l-14.623 81.891C234.523 473.246 240.178 480 247.65 480h40.632a12 12 0 0 0 11.813-9.891L315.472 384h79.096a12 12 0 0 0 11.813-9.891l7.143-40c1.313-7.355-4.342-14.109-11.813-14.109h-74.81l22.857-128h79.096a12 12 0 0 0 11.813-9.891zM261.889 320h-98.634l22.857-128h98.634l-22.857 128z"/>
</symbol>


  <symbol viewBox="0 0 320 512" id="caret-down">
    <path d="M31.3 192h257.3c17.8 0 26.7 21.5 14.1 34.1L174.1 354.8c-7.8 7.8-20.5 7.8-28.3 0L17.2 226.1C4.6 213.5 13.5 192 31.3 192z"/>
  </symbol>


      
      
      
    </svg>

    
    
    

      <script>
        
          'use strict';const PALETTE=document.querySelector('footer input');PALETTE.onchange=function(){const PICK=PALETTE.value;SHEET.setProperty('--accent',PICK);if(ROOT.dataset.mode==='light'){localStorage.setItem('lightAccent',PICK)}else{localStorage.setItem('darkAccent',PICK)};updateAccent()};
        
      </script>

    
    
    
    

  </body>
</html>
